import * as i0 from '@angular/core';
import { Injectable, Component, ChangeDetectionStrategy, ChangeDetectorRef, ElementRef, NgZone, NgModule } from '@angular/core';
import { __decorate } from 'tslib';
import { fromEvent } from 'rxjs';

class ComponentLibraryService {
    constructor() { }
}
ComponentLibraryService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ComponentLibraryService_Factory() { return new ComponentLibraryService(); }, token: ComponentLibraryService, providedIn: "root" });
ComponentLibraryService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
ComponentLibraryService.ctorParameters = () => [];

class ComponentLibraryComponent {
    constructor() { }
    ngOnInit() {
    }
}
ComponentLibraryComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-component-library',
                template: `
    <p>
      component-library works! Ok Ok
    </p>
  `
            },] }
];
ComponentLibraryComponent.ctorParameters = () => [];

/* eslint-disable */
const proxyInputs = (Cmp, inputs) => {
    const Prototype = Cmp.prototype;
    inputs.forEach(item => {
        Object.defineProperty(Prototype, item, {
            get() {
                return this.el[item];
            },
            set(val) {
                this.z.runOutsideAngular(() => (this.el[item] = val));
            }
        });
    });
};
const proxyMethods = (Cmp, methods) => {
    const Prototype = Cmp.prototype;
    methods.forEach(methodName => {
        Prototype[methodName] = function () {
            const args = arguments;
            return this.z.runOutsideAngular(() => this.el[methodName].apply(this.el, args));
        };
    });
};
const proxyOutputs = (instance, el, events) => {
    events.forEach(eventName => instance[eventName] = fromEvent(el, eventName));
};
const defineCustomElement = (tagName, customElement) => {
    if (customElement !== undefined &&
        typeof customElements !== 'undefined' &&
        !customElements.get(tagName)) {
        customElements.define(tagName, customElement);
    }
};
// tslint:disable-next-line: only-arrow-functions
function ProxyCmp(opts) {
    const decorator = function (cls) {
        const { defineCustomElementFn, inputs, methods } = opts;
        if (defineCustomElementFn !== undefined) {
            defineCustomElementFn();
        }
        if (inputs) {
            proxyInputs(cls, inputs);
        }
        if (methods) {
            proxyMethods(cls, methods);
        }
        return cls;
    };
    return decorator;
}

let MyComponent = class MyComponent {
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
MyComponent.decorators = [
    { type: Component, args: [{
                selector: 'my-component',
                changeDetection: ChangeDetectionStrategy.OnPush,
                template: '<ng-content></ng-content>',
                inputs: ['first', 'last', 'middle']
            },] }
];
MyComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
MyComponent = __decorate([
    ProxyCmp({
        defineCustomElementFn: undefined,
        inputs: ['first', 'last', 'middle']
    })
], MyComponent);
let TestComponent = class TestComponent {
    constructor(c, r, z) {
        this.z = z;
        c.detach();
        this.el = r.nativeElement;
    }
};
TestComponent.decorators = [
    { type: Component, args: [{
                selector: 'test-component',
                changeDetection: ChangeDetectionStrategy.OnPush,
                template: '<ng-content></ng-content>'
            },] }
];
TestComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef },
    { type: NgZone }
];
TestComponent = __decorate([
    ProxyCmp({
        defineCustomElementFn: undefined
    })
], TestComponent);

// import {DIRECTIVES} from './stencil-generated';
class ComponentLibraryModule {
}
ComponentLibraryModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    ComponentLibraryComponent,
                    MyComponent
                ],
                imports: [],
                exports: [
                    ComponentLibraryComponent,
                    MyComponent
                ],
                // schemas: [CUSTOM_ELEMENTS_SCHEMA]
            },] }
];

/*
 * Public API Surface of component-library
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ComponentLibraryComponent, ComponentLibraryModule, ComponentLibraryService, MyComponent, TestComponent, ProxyCmp as ɵa };
//# sourceMappingURL=example-stencil-angular-library.js.map
